/* sivann at ntua.gr 1999
 * v0.1
 * run a command with a timeout
 */
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>

int pid;

void childhdl()
{
  while (wait(0)>0);
}

void timeout()
{
  
  fprintf(stderr,"Driiinn...");
  if (!kill(pid,2)) {
    fprintf(stderr,"pid %d is undead!\n",pid);
  }
  exit(2);
}
  
int
main(int argc,char **argv)
{
  int seconds,pid,i=0;
  char comm[1024];
  char *s="/bin/csh";
  
  if (argc<3) {
    fprintf(stderr,"Usage: timed <seconds> <command>\n");
    exit(-4);
  }
  seconds=atoi(argv[1]);
  if (!seconds) {
    fprintf(stderr,"Cannot set alarm to %s seconds\n",argv[1]);
    exit(-1);
  }

  comm[0]=0;
  fprintf(stderr,"Alarm set to %d seconds\n",seconds);
  while (--argc) {
    if (i++ > 0){
      strcat (comm, *++argv);
      strcat (comm, " ");
    }
    else ++argv;
  }
  fprintf(stderr,"Executing:%s\n",comm);
  if ((pid=fork())) {
    signal(SIGCHLD,childhdl);
    signal(SIGALRM, timeout);
    alarm (seconds);
    pause();
  }
  else {
    int r;
    r=execl(s,"timed","-cf",comm,0);
    if (r<0) {
      fprintf(stderr,"Executing:%s\n",comm);
      perror(comm);
      exit(-4);
    }
  }
return 0;  
}
